   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('ONESTBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('ONEST001.CLW')
Main                   PROCEDURE   !
     END
      Include('DDE.CLW'),ONCE
      Module('Windoze API')
        BringWindowToTop(Long),Byte,RAW,PASCAL,Name('BringWindowToTop'),PROC
      End
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'


 Include('cwsynchm.inc'),once
Limiter &IMutex,auto,Thread
Result Signed,auto
sCommandName String(255)
Channel Long

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
   sCommandName = Command('0')
   Loop i# = 1 to Len(Clip(sCommandName))
     If sCommandName[i#] = '\'
       sCommandName[i#] = '/'
     End
   End
  
   Limiter &= NewMutex(sCommandName)
   If Limiter &= NULL
     Halt(,'This wonderful program encountered a fatal problem starting up.')
   Else
     Result = Limiter.TryWait(500)
     If Result <= Wait:OK
        !Program started
     Elsif Result = Wait:Timeout
        Channel = DDEClient(sCommandName)
        If Channel <> 0
          DDEExecute(Channel,'INFRONT')
          DDEClose(Channel)
          Return
        End
     Else
       Halt(,'System problem trying to open configuration files.')
     End
   End
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('onestart.INI', NVD_INI)                     ! Configure INIManager to use INI file
  DctInit
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
   Limiter.Release()
   Limiter.Kill()
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

